; CS-301 - Programming Assignment 4
; Author:  Tim Potter
; Date Due: 4/3/07

.386
.MODEL FLAT

ExitProcess PROTO NEAR32 stdcall, dwExitCode:DWORD

GetStdHandle PROTO NEAR32 stdcall,
	nStdHandle:DWORD
	
WriteFile PROTO NEAR32 stdcall,
	hFile:DWORD, lpBuffer:NEAR32, nNumberOfCharsToWrite:DWORD,
	lpNumberOfBytesWritten:NEAR32, lpOverlapped:NEAR32

CreateFileA PROTO NEAR32 stdcall,
	lpFileName:NEAR32, access:DWORD, shareMode:DWORD,
	lpSecurity:NEAR32, creation:DWORD, attributes:DWORD, copyHandle:DWORD
	
CloseHandle PROTO NEAR32 stdcall,
	fHandle:DWORD

INCLUDE io.h

STD_OUTPUT		EQU	-11
GENERIC_WRITE	EQU	40000000h
CREATE_ALWAYS	EQU	2
cr				EQU	0dh
lf				EQU	0ah

.STACK	4096

.DATA

	AR1		WORD	30 DUP (?)
	AR2		WORD	30 DUP (?)
	num		WORD	?
	oput	BYTE	6 DUP (?)," ",cr,lf
	strIn	BYTE	?
	fName	BYTE	"prg4out.txt",0
	written	DWORD	?
	hStdOut	DWORD	?
	hFile	DWORD	?
	
	nextLn	BYTE	cr,lf
	lineOut	BYTE	"Welcome to the Prime # Generator", cr,lf,lf,lf
			BYTE	"This program will generate the next 30",cr,lf
			BYTE	" prime numbers after the requested value",cr,lf,lf
	prompt	BYTE	"Please enter a positive 4 digit integer: ",cr,lf,lf,lf
	fileOut	BYTE	"Generated Prime Numbers after "
	endOut	BYTE	"All numbers generated... check output file",cr,lf,lf
			BYTE	"Bye ...",cr,lf
	
	
	
	
.CODE
IsPrimeOrNot	PROC	NEAR32
; BX is coming with a number and this proc checks if this number is prime or not. If yes, BX returns unchanged, else BX returns 0.
; BE SURE TO RESTORE OTHER REGISTERS (pushad and popad)

	pushad					; Saving register  and flag values from calling proc
	pushfd

	mov		cx,2

tester:	
	mov		ax,bx
	cmp		cx,ax			; Compare divisor and testing number, if equal, all divisors have been tested.
	je		prime
	sub 	dx,dx
	div		cx
	cmp		dx,0			; Is the remainder 0? 
	je		notprime		; --return BX as 0
	inc		cx				; Next Divisor
	jmp		tester			; Loop
	

prime:
	popfd					; Restoring register and flag values, leaving BX unchanged
	popad
	ret
	
notprime:	
	popfd					; Restoring register and flag values, then modifying BX to 0
	popad
	mov		bx,0
	ret
IsPrimeOrNot	ENDP


GetPrimeNums	PROC	NEAR32
; SI is coming with a number and this proc has to generate 30 prime #'s that are larger than this. EDI is bringing the address of
; an array of 30 Words in which the prime numbers are to be stored.  For every potential #, this proc loads it into BX and calls
; IsPrimeOrNot to check if its prime or not.  If yes, # is stored in the array, else the next # is tried.
; BE SURE TO RESTORE ALL REGISTERS
	
	pushad					; Saving register  and flag values from calling proc
	pushfd
	
	mov		ecx,30			; Loop 30 times to get prime #'s
	mov		edx,edi			; Store address of array in moving pointer
	
next:
	mov		bx,si			; Start testing with first potential number
	inc		si				; Prepare next testing number	
	call	IsPrimeOrNot	; Test for prime
	cmp		bx,0			; Was the potential number a prime?
	je		next			; No? - Try next potential number
	mov		[edx],bx		; Yes? - Put prime number in array
	add		edx,2			; move pointer to next array element
	
	loop	next			; try next potential number and decrement ECX
	
	popfd					; Restoring register and flag values
	popad
	ret						; Once all primes are found, return to caller
GetPrimeNums	ENDP


WritePrimeNums	PROC	NEAR32
; EDI is pointing to an array of 30 Words and this proc has to write numbers from this array to a file, 5 to a line.
; BE SURE TO RESTORE ALL REGISTERS
	
	pushad					; Saving register  and flag values from calling proc
	pushfd
	
	mov		ecx,30			; Output 30 numbers from array.
next:
	mov		ax,[edi]		; Store number in register
	itoa	oPut,ax			; convert prime to ASCII
	
	push	ecx
	
	INVOKE WriteFile,		; Initial file output
		hFile,				; file location
		NEAR32 PTR oPut,	
		8,					; fileout length
		NEAR32 PTR written,
		0
	
	pop		ecx				; return counter value
	add		edi,4			; go to next array element
	loop	next
	
	popfd
	popad
	ret
	
WritePrimeNums	ENDP


_start:

	INVOKE CreateFileA,		; open file
		NEAR32 PTR fName,	; file name
		GENERIC_WRITE,		; access
		0,					; no sharing
		0,					; no predefined security
		CREATE_ALWAYS,		; open if file doesn't exist
		0,					; no special attributes
		0					; no copied handle
		mov hFile, eax		; handle for file
		

	INVOKE GetStdHandle,	; Prepare output
		STD_OUTPUT			;   --  to screen
	mov hStdOut, eax
		
	INVOKE WriteFile,		; Initial output
		hStdOut,			; screen hardware location
		NEAR32 PTR lineOut,	
		164,				; lineout and prompt
		NEAR32 PTR written,	
		0
	
	input	strIn, 6		; Read 4 digit # into strIn (6 ascii # max)
	atoi	strIn			; Convert ascii to doubleword
	mov		num,ax			; Store in num
	mov		si,num			; copy to tester value
	
	lea		EDI,AR1			; Stores location of array1 to EDI
	
	call	GetPrimeNums

	INVOKE WriteFile,		; Initial file output
		hFile,				; file location
		NEAR32 PTR fileOut,	
		30,					; fileout length
		NEAR32 PTR written,
		0

;	INVOKE WriteFile,		; Initial file output
;		hFile,				; file location
;		NEAR32 PTR ax,	
;		2,					; fileout length
;		NEAR32 PTR written,
;		0


	call	WritePrimeNums
	

	INVOKE WriteFile,		; Initial output
		hStdOut,			; screen hardware location
		NEAR32 PTR prompt,	
		45,					; prompt
		NEAR32 PTR written,	
		0
	
	input	strIn, 6		; Read 4 digit # into strIn (6 ascii # max)
	atoi	strIn			; Convert ascii to doubleword
	mov		num,ax			; Store in num
	mov		si,num			; copy to tester value
	
	lea		EDI,AR2			; Stores location of array1 to EDI
	
	call	GetPrimeNums

	INVOKE WriteFile,		; Initial file output
		hFile,				; file location
		NEAR32 PTR fileOut,	
		30,					; fileout length
		NEAR32 PTR written,
		0
	
;	INVOKE WriteFile,		; Initial file output
;		hFile,				; file location
;		NEAR32 PTR ax,	
;		2,					; fileout length
;		NEAR32 PTR written,
;		0

	call	WritePrimeNums
	

closing:	
	INVOKE WriteFile,		; Initial output
		hStdOut,			; screen hardware location
		NEAR32 PTR endOut,	
		54,					; lineout and prompt
		NEAR32 PTR written,	
		0
	
	INVOKE	CloseHandle,	; close output file
		hFile
		
	INVOKE	ExitProcess, 0	; exit with return code of 0
	
PUBLIC _start				; make entry point public

END							; end of source code
	
	
